//---------------------------------------------------------------------
//
// 8hbg@ttLED@ for ATmega328P     @@@@@@bytRP i2018.11j
// 
// EL[ŃJ[\ړC㉺L[ŕIij
// EL[Ń[hؑցi\Cݒj
// L[ŕNACXɒŏ\
// 
//---------------------------------------------------------------------

#include <avr/io.h>
#include <avr/eeprom.h>
#include "sw.h"
#include "font.h"

#define LEDWIDTH 8       // LEDhbg

//#define SWCHKCNT 160     // XCb`o[v
#define WAITLOOP 200     // [vɓKȃfBC^
#define SCROLSPD 400     // XN[Xs[h

unsigned char ledvram[LEDWIDTH];    // LED Bitmap Buffer
unsigned char displayram[240];		// 6P~SÕm
unsigned char st[40];

#define LEDCOL   PORTB   // LED()p|[g
#define LEDCOLOE DDRB

#define SW_UP     (1<<0)	// PC0
#define SW_DOWN   (1<<1)	// PC1
#define SW_RIGHT  (1<<2)	// PC2
#define SW_LEFT   (1<<3)	// PC3


#define SW_ALL    (SW_UP|SW_DOWN|SW_LEFT|SW_RIGHT)

void led_init(void);
void led_disp(void);

//---------------------------------------------------------------------
// LED
void led_init(void)
{
    LEDCOLOE = 0xff;    //output
}

//---------------------------------------------------------------------
void put_chr(unsigned char ch){
	int i;
	for (i=0;i<5;i++) ledvram[i]=Font[ch][i];
}

//---------------------------------------------------------------------
// EEPROM當ǂݏost[]ɃXgA
void romrd(void){
	int i;
	for(i=0;i<40;i++){		
	 	st[i]=eeprom_read_byte (i);
	}
}

//---------------------------------------------------------------------
// EEPROMɕL^
void romwd(void){
	int i;
	eeprom_write_byte (0, 0);
	for(i=1;i<40;i++){		
	 	eeprom_write_byte (i, st[i]);
	}
}

//---------------------------------------------------------------------
// EEPROMNA
void stclr(void){
	int i;
	for(i=0;i<40;i++) st[i]=0;
	romwd();
}

//---------------------------------------------------------------------
// ̏
void stinit(void){
	int i;

	st[0]=0; 	// " "
	st[1]=11; 	// "K"
	st[2]=47; 	// "u"
	st[3]=39; 	// "m"
	st[4]=27; 	// "a"
	st[5]=39; 	// "m"
	st[6]=41; 	// "o"
	st[7]=46; 	// "t"
	st[8]=41; 	// "o"
	st[9]=73; 	// "-"
	st[10]=14; 	// "N"
	st[11]=3; 	// "C"
	st[12]=20; 	// "T"

	for(i=13;i<40;i++) st[i]=0;
	romwd();
}


//---------------------------------------------------------------------
// C
int main(void)
{
    unsigned char i,j,k;	// ėpJE^
    unsigned int t;		// [v̊Ԃ̃fBCJE^
    unsigned char seq;		// V[PX̒liOFݒCPF\CQF[v\j
	int cnt=0;				// XN[̃^C~O߂JE^
	int loc=0;
	int ch;		// P\̃LN^R[h
	unsigned char keyup=0;	// L[𗣂ǂ̃tO
	unsigned int  upcnt=0;	// up/downL[𗣂ȂƂA͂邽߂̃JE^
    unsigned int  keycnt=0; // EL[opJE^CV[PXؑ
    unsigned int  clrcnt=0; // L[opJE^CNA

    int pos=1;        		// 쐬̕
	int len=1;
	
	unsigned char row=0;		// led\ʒu
	unsigned char rowMax=7;	// \̈
	
	unsigned char tmp;

    sw_init(SW_ALL);
    led_init();
    seq = 1;

	// EEPROM當ǂݏo
	romrd();
	ch=st[1];				// ŏ̕chɓǂݏo

    while(1)
    {

		// LED\
		
		// U當񂪕\ԁCSɕ\
		if (seq==2){					
			// ԈႢȂꍇ    	
			// LEDCOL = displayram[(int)row]; //LED_		
				
            // ԈႢꍇ
			// PB6PB7tɂĂ܂̂ŁCŃ\tgIɓւ
		    tmp = displayram[(int)row]; //LED_
		    LEDCOL =  ((tmp >> 1) & 0x40) | ((tmp << 1) & 0x80) | (tmp & 0x3f);
			
    		row = (row+1) % rowMax;	
			
		// ͎CP\iledvramj	
		} else{							
			// ԈႢȂꍇ 
    		// LEDCOL = ledvram[(int)row]; //LED_

			// ԈႢꍇ
			// PB6PB7tɂĂ܂̂ŁCŃ\tgIɓւ
		    tmp = ledvram[(int)row]; //LED_
		    LEDCOL =  ((tmp >> 1) & 0x40) | ((tmp << 1) & 0x80) | (tmp & 0x3f);	
			
    		row = (row+1) % LEDWIDTH;	
		}
		for(t=0; t<WAITLOOP; t++) asm("NOP");	// [vɓKȑ҂Ԃ^

        switch(seq)
        {

        case 0:     // 

			if (sw_get(SW_DOWN)==0 && sw_get(SW_UP)==0 && sw_get(SW_LEFT)==0 && sw_get(SW_RIGHT)==0) keyup=0;
			
			if (sw_get(SW_DOWN) && keyup==0) {   // {^
				keyup=1;
				ch++; if (ch>77) ch=0;
				st[pos]=ch; 
			}

			if (sw_get(SW_UP) && keyup==0) {   // {^
				keyup=1;
				ch--; if (ch<0) ch=77;
				st[pos]=ch; 
			}

			if (sw_get(SW_DOWN) || sw_get(SW_UP)) {
				upcnt++; if (upcnt>3000) {upcnt=2500; keyup=0;}		
			} else upcnt=0;

			if (sw_get(SW_LEFT) && keyup==0) {   // {^
				keyup=1;
				pos--; if (pos<1) pos=1;
				ch=st[pos];
			}

			if (sw_get(SW_RIGHT) && keyup==0) {   // E{^iE{^̓[hؑւƂpj
				keyup=1;
				pos++; if (pos>39) pos=39;
				ch=st[pos];
			}

			put_chr(ch);
            break;

        case 1: 	// ̕\f[^Zbg

			for(i=0;i<240;i++) displayram[i]=0;	// fBXvCRAMNA
			len=39;
			while(st[len]==0 && len>1) len--; // 󔒂𓾂
					
			k=0;
			for(i=0;i<(len+1);i++){
				for (j=0;j<5;j++){
			 		displayram[k]=Font[st[i]][j];
			 		k++;
				}
				displayram[k]=0;
				k++;
			}		
			seq=2;
			rowMax=k;
			break;

        case 2:	// \̓[v̍ŏł̂łł͉Ȃ
			break;
        }

		// EL[ŃV[PXؑցiZbgL[łj
		if (sw_get(SW_RIGHT)) { 	
			keycnt++; 
			if (keycnt>500) {			// ̔f
				keycnt=0;
				if (seq==0) {			// ݒԂ當XN[
					seq=1;				
					romwd();			// eepromɕL^
				}
				if (seq==2) {			// XN[ݒԂ
					seq=0; 
					rowMax=7;
					pos=1;
					ch=st[pos];
					for (i=0;i<8;i++) ledvram[i]=0;	// ݒԂɖ߂Ƃʂ̃S~łȂ悤ɃNA
				}
			}
		} else keycnt=0;				// L[ꂽCJE^Zbg

		// L[ŃNACɒŏݒ
		if (sw_get(SW_LEFT)) { 	
			clrcnt++; 
			if (clrcnt==500){			// XɒƂCNA
				stclr();	
				seq=0;
				rowMax=7;	
				pos=1;
				st[1]=ch=1;
				for (i=0;i<8;i++) ledvram[i]=0;	// ݒԂɖ߂Ƃʂ̃S~łȂ悤ɃNA
			}
			if (clrcnt==1000){			// XɒƂCNA
				seq=1;	
				stinit();	
			}
		} else clrcnt=0;				// L[ꂽCJE^Zbg

    }	// while[vI
}		// C[vI

